﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;   // Need to import for using DLL

namespace Nuvia_C_Sharp
{
    public partial class Form1 : Form
    {
        [StructLayout(LayoutKind.Explicit)]
        public struct Rect
        {
            [FieldOffset(0)]
            public int top;
            [FieldOffset(4)]
            public int left;
            [FieldOffset(8)]
            public int bottom;
            [FieldOffset(12)]
            public int right;
        }
        public class NuviaDll
        {
            [DllImport("TP9000.dll")]
            public static extern int ListDevices(ref int pArg1, byte[] pArg2, uint dwFlags);

            [DllImport("TP9000.dll")]
            public static extern int OpenDeviceEx(string pSerial, uint dwFlag);

            [DllImport("TP9000.dll")]
            public static extern int Get_PrinterInfo(byte[] pSerial);

            [DllImport("TP9000.dll")]
            public static extern int CloseDevice(int iDeviceType);

            [DllImport("TP9000.dll")]
            public static extern int Card_Insert();

            [DllImport("TP9000.dll")]
            public static extern int Card_Eject(int nOption);

            [DllImport("TP9000.dll")]
            public static extern int MS_Read(int iTrack, byte[] pTrack1, byte[] pTrack2, byte[] pTrack3);

            [DllImport("TP9000.dll")]
            public static extern int N_MS_Write(int iTrack, byte[] pTrack1, byte[] pTrack2, byte[] pTrack3, byte[] pJis, int nJis);

            [DllImport("TP9000.dll")]
            public static extern int IC_ContactOn();

            [DllImport("TP9000.dll")]
            public static extern int IC_Eject(int nCmd);

            [DllImport("TP9000.dll")]
            public static extern int IC_PowerOn(int cno, ref uint pdwRXSize, byte[] lpbRXData);

            [DllImport("TP9000.dll")]
            public static extern int IC_PowerOff(int cno);

            [DllImport("TP9000.dll")]
            public static extern int IC_Input(int cno, uint dwTXSize, byte[] lpbTXData, ref uint pdwRXSize, byte[] lpbRXData);

            [DllImport("TP9000.dll")]
            public static extern int N_StartOfPrinting(int p1);

            [DllImport("TP9000.dll")] // K(mono) : N_SetPrintType(4,1,0)
            public static extern int N_SetPrintType(int p1, int p2, int p3);

            [DllImport("TP9000.dll")] // Clear front side image buffer : N_ClearImageBuffer(0x3F,0);
            public static extern int N_ClearImageBuffer(int p1, int p2);

            [DllImport("TP9000.dll")] // TextToBmpMakeEx
            public static extern int TextToBmpMakeEx(string cFilename, string cStr, string Fontname, char Fonttype, int Fontsize, int Resolution);

            [DllImport("TP9000.dll")]
            public static extern int N_PrintPanel(int p1, int p2);

            [DllImport("TP9000.dll")]
            public static extern int N_CancelPrintJob(int pJobNo);

            [DllImport("TP9000.dll")] // 0x00 : idle, 0x01 : in priting, 0xFF : Error Print Stop
            public static extern int N_PrintJobStatus(int[] pJobStatus);

            [DllImport("TP9000.dll")]
            public static extern int N_EndOfPrint(int nPanel, ref int pPanelCount, ref int pJobNo);

            [DllImport("TP9000.dll")]
            public static extern int N_SetImageBuffer(int p1, int p2, int p3, int p4, int p5, int p6, string pFile);

            [DllImport("TP9000.dll")]
            public static extern int N_TransferImageData(int p1, int p2, int p3, int p4, int p5, string pFile);

            [DllImport("TP9000.dll")]
            public static extern int CheckSIM(int nPort, ref int pStatus);

            [DllImport("TP9000.dll")]
            public static extern int GetRibbonSensorEx(ref int nWhite, ref int nBlue);

            [DllImport("TP9000.dll")]
            public static extern int CheckRibbonEx(ref int pRibbon, ref int pRFRibbon);

            [DllImport("TP9000.dll")]
            public static extern int CheckRibbonCount(ref int pRibbonCnt);

            [DllImport("TP9000.dll")]
            public static extern int CheckFeeder(ref int pStatus);

            [DllImport("TP9000.dll")]
            public static extern int SetRibbonSync();

            [DllImport("TP9000.dll")]
            public static extern int Get_Status(ref byte st0, ref byte st1);

            [DllImport("TP9000.dll")]
            public static extern int GetProductSerialNo(byte[] pSerial);

            [DllImport("TP9000.dll")]
            public static extern int GetStatusCode(ref int pStatus);
            
           [DllImport("TP9000.dll")]
            public static extern int DeviceErrorClear();
           /* [StructLayout(LayoutKind.Explicit)]
            public struct Rect
            {
                [FieldOffset(0)]
                public int top;
                [FieldOffset(4)]
                public int left;
                [FieldOffset(8)]
                public int bottom;
                [FieldOffset(12)]
                public int right;
            }*/
            [DllImport("TP9000.dll")]
            public static extern int Image_VarnishSendEx(int nType, ref Rect lpBlack, ref Rect lpWhite);
        }
        #region Class 변수
        byte[] pSerial = new byte[128];
        #endregion
        public Form1()
        {
            InitializeComponent();
            richTextBoxLog.SelectionStart = richTextBoxLog.Text.Length;
        }
        internal static readonly char[] g_HexDigits = new char[] { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F' };

        private void OpenDev_Click(object sender, EventArgs e)
        {
            int iRet;
            int dwCount = 0;
            int dwIndex = 0;
            uint dwFlags;

            //Get the number of connected device          
            dwFlags = 0x80000000;
            iRet = NuviaDll.ListDevices(ref dwCount, this.pSerial, dwFlags);
            if ((iRet != 0) || (dwCount == 0))
                return ;

            //Get the Serial number of connected device
            dwFlags = 0x00000001;
            for (dwIndex = 0; dwIndex < dwCount; dwIndex++)
            {
                iRet = NuviaDll.ListDevices(ref dwIndex, this.pSerial, dwFlags);
                if ((iRet == 0) && (this.pSerial.Length > 0))
                {
                    //string serial = this.pSerial.ToString();
                    byte[] pVer = new byte[20];

                    iRet = NuviaDll.OpenDeviceEx(this.pSerial.ToString(), 0x00000001);
                    if (iRet == 0)
                    {
                        iRet = NuviaDll.Get_PrinterInfo(pVer);
                        IDC_EDIT_PROC.Text = "OpenDevice - OK";
                        DisplayProcessLog(IDC_EDIT_PROC.Text);
                        return;
                    }
                    else
                    {
                        IDC_EDIT_PROC.Text = "OpenDevice - Fail";
                    }
                    return;
                }
            }
        }

        private void GetStatus_Click(object sender, EventArgs e)
        {
            byte st0 = 0, st1 = 0;
            if (NuviaDll.Get_Status(ref st0, ref st1) == 0)
            {
                IDC_EDIT_PROC.Text = "Get Status = " + (st0.ToString("X") + "h " + st1.ToString("X") + "h");
                DisplayProcessLog(IDC_EDIT_PROC.Text);
            }
        }

        private void GetSerialNum_Click(object sender, EventArgs e)
        {
            int ret = 0; 
            byte[] pSerialNumber = new byte[78];
            ret = NuviaDll.GetProductSerialNo(pSerialNumber);
            if (ret == 0)
            {
                IDC_EDIT_PROC.Text = "Serial Number : " +Encoding.Default.GetString(pSerialNumber);
                DisplayProcessLog(IDC_EDIT_PROC.Text);
            }
            else
            {
                IDC_EDIT_PROC.Text = "GetProductSerialNo - Fail";
            }

        }
        
        private void PrintDual_Click(object sender, EventArgs e)
        {
            int iRet = 0;
            int pStatus = 0;
            int nPnlCnt = 0;
            int nJobNo = 0;
            int[] nJobSt = new int[20] ;
            int nRibbon = 0;
            int nRfRibbon = 0;
            int nRibCnt = 0;
            string hexOutput;
            string msg1;
            string msg2;
            

            Rect rect1;
            Rect rect2;
            rect1.top = 0;
            rect1.left = 0;
            rect1.bottom = 0;
            rect1.right = 0;

            rect2.top = 0;
            rect2.left = 0;
            rect2.bottom = 0;
            rect2.right = 0;

            NuviaDll.CheckFeeder(ref pStatus);
            if ((((byte)pStatus & 0x10) != 0x10) && (((byte)pStatus & 0x80) != 0x80))
            {
                iRet = NuviaDll.Card_Insert();       
            }
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [Card_Insert]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }

            iRet = NuviaDll.CheckRibbonEx(ref nRibbon, ref nRfRibbon);
            if (iRet == 0)
            {
                switch (nRibbon)
                {
                    case 0:         msg1 = "Not Check / "; break;
                    case 0x30:      msg1 = "Color Ribbon / "; break;
                    case 0x34:      msg1 = "Mono Ribbon / "; break;
                    default:        msg1 = "미정의 / "; break;
                }
                switch (nRfRibbon)
                {
                    case 0:         msg2 =  "None"; break;
                    case 0x30:      msg2 =  "Black(Mono)"; break;
                    case 0x31:      msg2 =  "YMCKO"; break;
                    case 0x32:      msg2 =  "YMCKOK"; break;
                    case 0x33:      msg2 =  "Half-YMCKO"; break;
                    case 0x34:      msg2 =  "KO"; break;
                    case 0x35:      msg2 =  "K"; break;
                    case 0x36:      msg2 =  "Gold"; break;
                    case 0x3B:      msg2 =  "White"; break;
                    case 0x3C:      msg2 =  "Silver"; break;
                    case 0x3E:      msg2 =  "Red"; break;
                    case 0x3F:      msg2 =  "Blue"; break;
                    default:        msg2 =  "미정의"; break;
                }
                IDC_EDIT_PROC.Text = "Check Ribbon" + msg1 + msg2;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
            }
            else
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [CheckRibbonEx]: " + hexOutput;
                return;
            }

            iRet = NuviaDll.CheckRibbonCount(ref nRibCnt);
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [CheckRibbonCount]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            IDC_EDIT_PROC.Text = "Available ribbon count = " + nRibCnt.ToString("0000");
            DisplayProcessLog(IDC_EDIT_PROC.Text);

            DisplayProcessLog("Start to print a dual color !!");

            System.Threading.Thread.Sleep(1000);
            
            iRet = NuviaDll.N_StartOfPrinting(0);
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_StartOfPrinting]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.N_SetPrintType(0, 1, 0);
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_SetPrintType]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }

            iRet = NuviaDll.N_ClearImageBuffer(0x3F, 0);    //front side buffer clear
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_ClearImageBuffer]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.N_SetImageBuffer(0, 0, 0x63, 0, 255, 0, "Sample1.jpg"); // last parameter = image name, image send
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_SetImageBuffer]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.TextToBmpMakeEx("Name_front.bmp", "POINTMAN", "Arial", '0', 11, 300);   //text -> bmp make
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [TextToBmpMakeEx]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.N_SetImageBuffer(50, 550, 0x6B, 48, 255, 0, "Name_front.bmp");  // text bmp file send
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_SetImageBuffer]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.Image_VarnishSendEx(0, ref rect1, ref rect2);   //overlay
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [Image_VarnishSendEx]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.N_TransferImageData(0, 0, 0, 0, 413, null);     //total  image data front send
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_TransferImageData]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.N_PrintPanel(0, 0x30); //front print after flip the card
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_PrintPanel]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            // if single side print : N_PrintPanel(0, 0)

            iRet = NuviaDll.N_ClearImageBuffer(0xBF, 0);    //back side buffer clear
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_ClearImageBuffer]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.N_SetImageBuffer(0, 0, 0x63, 0, 255, 0, "Sample2.bmp");
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_SetImageBuffer]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.TextToBmpMakeEx("Name_back.bmp", "HELLO WORLD", "Arial", '0', 11, 300);
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [TextToBmpMakeEx]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.N_SetImageBuffer(50, 550, 0x6B, 48, 255, 0, "Name_back.bmp");
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_SetImageBuffer]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.Image_VarnishSendEx(0, ref rect1, ref rect2);   //overlay
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [Image_VarnishSendEx]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.N_TransferImageData(128, 0, 0, 0, 413, null);   // total image data back send
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_StartOfPrinting]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.N_PrintPanel(0x80, 0);                          //back side print after eject the card.
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_PrintPanel]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.N_EndOfPrint(2, ref nPnlCnt, ref nJobNo);       //print action start
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_EndOfPrint]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }

            int nRepeatCnt = 0;

            while (iRet == 0)
            {
                System.Threading.Thread.Sleep(1000);
                
                iRet = NuviaDll.N_PrintJobStatus(nJobSt);   //printing status check
                NuviaDll.GetStatusCode(ref pStatus);        //status code check

                if (nJobSt[0] != 0x01)  // 0x01 = printing. 
                {
                    if (nJobSt[0] == -1)    // error happend
                    {
                        hexOutput = String.Format("{0:X}", pStatus);
                        IDC_EDIT_PROC.Text = "Print finished.  Error : " + hexOutput;
                        DisplayProcessLog(IDC_EDIT_PROC.Text);
                        NuviaDll.N_CancelPrintJob(nJobSt[1]);
                    }
                    else
                    {
                        IDC_EDIT_PROC.Text = "Print - OK";
                        DisplayProcessLog(IDC_EDIT_PROC.Text);
                    }
                    break;
                }
                // 20170607 Added
                if (pStatus != 0x3030)    // error happend  0x3030 converts to the decimal value, 12336.
                {
                    if (pStatus != 0x3335)   // ribbon near end
                    {
                        // warning, ribbon near end
                        hexOutput = String.Format("{0:X}", pStatus);
                        IDC_EDIT_PROC.Text = "Print Error : " + hexOutput;
                        DisplayProcessLog(IDC_EDIT_PROC.Text);
                        NuviaDll.DeviceErrorClear();
                        NuviaDll.N_CancelPrintJob(nJobSt[1]);
                        break;
                    }
                    //else if (pStatus == 0x3336) //ribbon end
                    //{
                    //    IDC_EDIT_PROC.Text = "Ribbon End";
                    //    NuviaDll.DeviceErrorClear();
                    //}
                }
                nRepeatCnt++;
                hexOutput = String.Format("Check count = " + nRepeatCnt.ToString("00") + ", Result = {0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Check the printing status : " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
            }
        
        }

        private void EjectCard_Click(object sender, EventArgs e)
        {
            int iRet = 0;
            iRet = NuviaDll.Card_Eject(0);
            if (iRet == 0)
            {
                IDC_EDIT_PROC.Text = "Card_Eject - OK";
            }
            else 
            {
                IDC_EDIT_PROC.Text = "Card_Eject - Fail";
            }

        }
        
        private void ReadMS_Click(object sender, EventArgs e)
        {
            int iRet = 0;
            int pStatus = 0;
            uint nRx = 0;
            byte[] pTrack1 = new byte[78];
            byte[] pTrack2 = new byte[39];
            byte[] pTrack3 = new byte[106];

            NuviaDll.CheckFeeder(ref pStatus);
            if ((((byte)pStatus & 0x10) != 0x10) && (((byte)pStatus & 0x80) != 0x80))
            {
                iRet = NuviaDll.Card_Insert();
            }

            iRet = NuviaDll.MS_Read(4, pTrack1, pTrack2, pTrack3);
            if (iRet == 0)
            {
                textBoxDecTrack1.Text = Encoding.Default.GetString(pTrack1);
                textBoxDecTrack2.Text = Encoding.Default.GetString(pTrack2);
                textBoxDecTrack3.Text = Encoding.Default.GetString(pTrack3);
                IDC_EDIT_PROC.Text = "MS_Read - OK";
            }
            else
            {
                IDC_EDIT_PROC.Text = "MS_Read - Fail";
            }

            iRet = NuviaDll.Card_Eject(0);

        }

        private void WriteMS_Click(object sender, EventArgs e)
        {
            int iRet = 0;
            byte[] pTrack1 = new byte[78];
            byte[] pTrack2 = new byte[39];
            byte[] pTrack3 = new byte[106];

            pTrack1 = System.Text.Encoding.ASCII.GetBytes(textBoxEncTrack1.Text);
            pTrack2 = System.Text.Encoding.ASCII.GetBytes(textBoxEncTrack2.Text);
            pTrack3 = System.Text.Encoding.ASCII.GetBytes(textBoxEncTrack3.Text);
            iRet = NuviaDll.N_MS_Write(0x07, pTrack1, pTrack2, pTrack3, null, 0);
            if (iRet == 0)
            {
                IDC_EDIT_PROC.Text = "MS Write - OK";
            }
            else
            {
                IDC_EDIT_PROC.Text = "MS Write - Fail";
            }

            iRet = NuviaDll.Card_Eject(0);

        }

        private void TestIC_Click(object sender, EventArgs e)
        {
            int iRet = 0;
            int pStatus = 0;
            uint nRx = 0;
            byte[] pRxATR = new byte[50];
            byte[] pTxApdu = new byte[512];
            uint nTxApdu = 0;
            byte[] pRxApdu = new byte[512];
            uint nRxApdu = 0;

            NuviaDll.CheckFeeder(ref pStatus);
            if ((((byte)pStatus & 0x10) != 0x10) && (((byte)pStatus & 0x80) != 0x80))
            {
                iRet = NuviaDll.Card_Insert();
            }

            iRet = NuviaDll.IC_ContactOn();
            if (iRet != 0)
            {
                IDC_EDIT_PROC.Text = "IC_ContactOn - Fail";
                return;
            }
            iRet = NuviaDll.IC_PowerOn(0, ref nRx, pRxATR);
            if (iRet != 0)
            {
                IDC_EDIT_PROC.Text = "IC_PowerOn - Fail";
                return;
            }
            textBoxIcAtr.Text = FromByteArray(pRxATR, (int)nRx*2);

            nTxApdu = (uint)textBoxIcApdu.Text.Length/2;
            // String -> Hex
            pTxApdu = StringToByteArray(textBoxIcApdu.Text);

            iRet = NuviaDll.IC_Input(0, nTxApdu, pTxApdu, ref nRxApdu, pRxApdu);    // apdu
            if (iRet != 0)
            {
                IDC_EDIT_PROC.Text = "IC_Input - Fail";
                return;
            }

            textBoxIcRsp.Text = FromByteArray(pRxApdu, (int)nRxApdu*2);

            iRet = NuviaDll.Card_Eject(0);
            if (iRet != 0)
            {
                IDC_EDIT_PROC.Text = "Card_Eject - Fail";
                return;
            }
            if (iRet == 0)
            {
                IDC_EDIT_PROC.Text = "IC Test - OK";
            }
            
        }
        private static byte[] StringToByteArray(string hex)  
        {  
            return Enumerable.Range(0, hex.Length)  
                             .Where(x => x % 2 == 0)  
                             .Select(x => Convert.ToByte(hex.Substring(x, 2), 16))  
                             .ToArray();  
        }
        public static string FromByteArray(byte[] byArr)
        {
            return FromByteArray(byArr, 0, byArr.Length);
        }

        public static string FromByteArray(byte[] byArr, int length)
        {
            return FromByteArray(byArr, 0, length);
        }

        public static string FromByteArray(byte[] byArr, int nOffset, int nLength)
        {
            if (byArr == null)
            {
                throw new ArgumentNullException();
            }
            if (((nOffset < 0) || (nLength < 0)) || ((nOffset + nLength) > byArr.Length))
            {
                throw new ArgumentOutOfRangeException();
            }
            char[] chArray = new char[nLength * 2];
            for (int i = 0; i < nLength; i++)
            {
                chArray[i * 2] = g_HexDigits[byArr[nOffset + i] >> 4];
                chArray[(i * 2) + 1] = g_HexDigits[byArr[nOffset + i] & 15];
            }
            return new string(chArray);
        }

        private void DisplayProcessLog(string strLog)
        {
            int nCurline = richTextBoxLog.GetLineFromCharIndex(richTextBoxLog.SelectionStart);
            if (nCurline > 300)
            {
                richTextBoxLog.Clear();
            }
//            richTextBoxLog.SelectionStart = richTextBoxLog.Text.Length;
            richTextBoxLog.ScrollToCaret();
            richTextBoxLog.AppendText(strLog+"\r\n");
            //richTextBoxLog.Text = strLog + "\r\n";
        }

        private void GetErrorcode()
        {
            int pStatus = 0;
            string strHex;
            NuviaDll.GetStatusCode(ref pStatus);        //status code check
            strHex = String.Format("{0:X}", pStatus);
            IDC_EDIT_PROC.Text = "Print Error [N_PrintPanel]: " + strHex;
            DisplayProcessLog(IDC_EDIT_PROC.Text);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int iRet = 0;
            int pStatus = 0;
            int nPnlCnt = 0;
            int nJobNo = 0;
            int[] nJobSt = new int[20];
            int nRibbon = 0;
            int nRfRibbon = 0;
            string hexOutput;
            string msg1;
            string msg2;


            Rect rect1;
            Rect rect2;
            rect1.top = 0;
            rect1.left = 0;
            rect1.bottom = 0;
            rect1.right = 0;

            rect2.top = 0;
            rect2.left = 0;
            rect2.bottom = 0;
            rect2.right = 0;

            NuviaDll.CheckFeeder(ref pStatus);
            if ((((byte)pStatus & 0x10) != 0x10) && (((byte)pStatus & 0x80) != 0x80))
            {
                iRet = NuviaDll.Card_Insert();
            }
            iRet = NuviaDll.CheckRibbonEx(ref nRibbon, ref nRfRibbon);
            if (iRet == 0)
            {
                switch (nRibbon)
                {
                    case 0: msg1 = "Not Check / "; break;
                    case 0x30: msg1 = "Color Ribbon / "; break;
                    case 0x34: msg1 = "Mono Ribbon / "; break;
                    default: msg1 = "미정의 / "; break;
                }
                switch (nRfRibbon)
                {
                    case 0: msg2 = "None"; break;
                    case 0x30: msg2 = "Black(Mono)"; break;
                    case 0x31: msg2 = "YMCKO"; break;
                    case 0x32: msg2 = "YMCKOK"; break;
                    case 0x33: msg2 = "Half-YMCKO"; break;
                    case 0x34: msg2 = "KO"; break;
                    case 0x35: msg2 = "K"; break;
                    case 0x36: msg2 = "Gold"; break;
                    case 0x3B: msg2 = "White"; break;
                    case 0x3C: msg2 = "Silver"; break;
                    case 0x3E: msg2 = "Red"; break;
                    case 0x3F: msg2 = "Blue"; break;
                    default: msg2 = "미정의"; break;
                }
                IDC_EDIT_PROC.Text = msg1 + msg2;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
            }
            else
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [CheckRibbonEx]: " + hexOutput;
                return;
            }

            System.Threading.Thread.Sleep(1000);
            DisplayProcessLog("Start to print a dual color !!");

            iRet = NuviaDll.N_StartOfPrinting(0);
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_StartOfPrinting]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.N_SetPrintType(4, 1, 0);
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_SetPrintType]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }

            iRet = NuviaDll.N_ClearImageBuffer(0x3F, 0);    //front side buffer clear
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_ClearImageBuffer]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.N_SetImageBuffer(0, 0, 109, 0, 255, 0, "Sample_mono.bmp"); // last parameter = image name, image send
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_SetImageBuffer]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.TextToBmpMakeEx("Name_front.bmp", "POINTMAN", "Arial", '0', 11, 300);   //text -> bmp make
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [TextToBmpMakeEx]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.N_SetImageBuffer(50, 550, 109, 48, 255, 0, "Name_front.bmp");  // text bmp file send
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_SetImageBuffer]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.N_TransferImageData(32, 0, 0, 0, 413, null);     //total  image data front send
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_TransferImageData]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.N_PrintPanel(32, 0x30); //front print after flip the card
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_PrintPanel]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            // if single side print : N_PrintPanel(0, 0)

            iRet = NuviaDll.N_ClearImageBuffer(0xBF, 0);    //back side buffer clear
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_ClearImageBuffer]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.N_SetImageBuffer(0, 0, 109, 0, 255, 0, "Sample_mono_BK.bmp");
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_SetImageBuffer]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            //iRet = NuviaDll.TextToBmpMakeEx("Name_back.bmp", "HELLO WORLD", "Arial", '0', 11, 300);
            //if (iRet != 0) // error handling. lower function also need handling.
            //{
            //    NuviaDll.GetStatusCode(ref pStatus);        //status code check
            //    hexOutput = String.Format("{0:X}", pStatus);
            //    IDC_EDIT_PROC.Text = "Print Error [TextToBmpMakeEx]: " + hexOutput;
            //    DisplayProcessLog(IDC_EDIT_PROC.Text);
            //    return;
            //}
            //iRet = NuviaDll.N_SetImageBuffer(50, 550, 109, 48, 255, 0, "Name_back.bmp");
            //if (iRet != 0) // error handling. lower function also need handling.
            //{
            //    NuviaDll.GetStatusCode(ref pStatus);        //status code check
            //    hexOutput = String.Format("{0:X}", pStatus);
            //    IDC_EDIT_PROC.Text = "Print Error [N_SetImageBuffer]: " + hexOutput;
            //    DisplayProcessLog(IDC_EDIT_PROC.Text);
            //    return;
            //}
            iRet = NuviaDll.N_TransferImageData(128, 0, 0, 0, 413, null);   // total image data back send
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_StartOfPrinting]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.N_PrintPanel(128, 0);                          //back side print after eject the card.
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_PrintPanel]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }
            iRet = NuviaDll.N_EndOfPrint(2, ref nPnlCnt, ref nJobNo);       //print action start
            if (iRet != 0) // error handling. lower function also need handling.
            {
                NuviaDll.GetStatusCode(ref pStatus);        //status code check
                hexOutput = String.Format("{0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Print Error [N_EndOfPrint]: " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
                return;
            }

            int nRepeatCnt = 0;

            while (iRet == 0)
            {
                System.Threading.Thread.Sleep(1000);

                iRet = NuviaDll.N_PrintJobStatus(nJobSt);   //printing status check
                NuviaDll.GetStatusCode(ref pStatus);        //status code check

                if (nJobSt[0] != 0x01)  // 0x01 = printing. 
                {
                    if (nJobSt[0] == -1)    // error happend
                    {
                        hexOutput = String.Format("{0:X}", pStatus);
                        IDC_EDIT_PROC.Text = "Print finished.  Error : " + hexOutput;
                        DisplayProcessLog(IDC_EDIT_PROC.Text);
                        NuviaDll.N_CancelPrintJob(nJobSt[1]);
                    }
                    else
                    {
                        IDC_EDIT_PROC.Text = "Print - OK";
                        DisplayProcessLog(IDC_EDIT_PROC.Text);
                    }
                    break;
                }
                // 20170607 Added
                if (pStatus != 0x3030)    // error happend  0x3030 converts to the decimal value, 12336.
                {
                    if (pStatus != 0x3335)   // ribbon near end
                    {
                        // warning, ribbon near end
                        hexOutput = String.Format("{0:X}", pStatus);
                        IDC_EDIT_PROC.Text = "Print Error : " + hexOutput;
                        DisplayProcessLog(IDC_EDIT_PROC.Text);
                        NuviaDll.DeviceErrorClear();
                        NuviaDll.N_CancelPrintJob(nJobSt[1]);
                        break;
                    }
                    //else if (pStatus == 0x3336) //ribbon end
                    //{
                    //    IDC_EDIT_PROC.Text = "Ribbon End";
                    //    NuviaDll.DeviceErrorClear();
                    //}
                }
                nRepeatCnt++;
                hexOutput = String.Format("Check count = " + nRepeatCnt.ToString("00") + ", Result = {0:X}", pStatus);
                IDC_EDIT_PROC.Text = "Check the printing status : " + hexOutput;
                DisplayProcessLog(IDC_EDIT_PROC.Text);
            }
        }
    }
}
